<template>
  <div>
    <label><b>Параметры обработки</b></label>
    <select v-model="selectedLevel">
      <option>L0</option>
      <option>L1</option>
      <option>L2</option>
      <option>L3M</option>
      <option>L3C</option>
    </select>
    <select v-model="selectedBandComb">
      <option></option>  
      <option>PAN</option>  
      <option>MS</option>
      <option>PMS</option>  
      <option>BUNDLE</option>  
    </select>
    <input size="50" width="50%" v-model="tamarinParam">
    <select v-model="selectedPriority">
      <option>HIGH</option>
      <option>NORMAL</option>  
      <option>LOW</option>
    </select>
  </div>

  <label>Префикс для заданий: </label>
  <input v-model="taskPrefix" />

  <div style="display: flex; justify-content: space-between;">
    <div>
      <label><b>ПАПКА</b></label>
      <input size="50" v-model="folder">
      <button @click="makeProductFromFolder">Задание на каждый маршрут</button>
    </div>

    <label><b>КАТАЛОГ</b></label>
    <div>
      <button @click="makeProductFromCatalog">Задание на каждый маршрут</button>
    </div>
    <div>
      <button @click="saveKit">Запомнить маршруты в наборе</button>
      <input size="30" v-model="kitName">
    </div>
    <div>
      <button @click="saveLink()">Выгрузить маршруты в папку</button>
      <input size="30" v-model="linkFolder">
    </div>
  </div>    

  <loader :active="loaderActive" message="Загрузка данных" />  

</template>


<script>
import { defineComponent, reactive, ref } from "vue";
import axios from 'axios';
import {redouteProvider} from  "../config/provider.js"
import Loader from '../components/Loader.vue'
import * as catalog from './Catalog.vue'


import { loadYmap } from 'vue-yandex-maps'

let map = null
let polygon = null

const searchTerm = ref(""); // Search text
const selectedLevel = ref('L2')
const selectedBandComb = ref('')
const selectedPriority = ref('NORMAL')    
const folder = ref('/mnt/beegfs/TEST/STAND_REDOUTE/samples')
const tamarinParam = ref('--portal')
const taskPrefix = ref('')
const coordsPolygon = reactive([]);
const linkFolder = ref('')
const kitName = ref('')


export default defineComponent({ 
  name: "App",
  components: { Loader },
  setup() {
    const result = ref('')
    const loaderActive = ref(false)

    const onInitMap = (mapFrom) => {
      map = mapFrom; 
      loadYmap({})
      /*
      var myPolygon = new window.ymaps.Polygon([], {}, {
        // Курсор в режиме добавления новых вершин.
        editorDrawingCursor: 'crosshair',
        // Максимально допустимое количество вершин.
        editorMaxPoints: 5,
        // Цвет заливки.
        fillColor: '#00FF00',
        // Цвет обводки.
        strokeColor: '#0000FF',
        // Ширина обводки.
        strokeWidth: 5
      })
      */

      polygon = new window.ymaps.Polygon(
        [],
        {
          // balloonContentHeader: "Перейти к подбору маршрутов",
        },
        {
          strokeWidth: 6,
          strokeColor: '#0000FF',
          draggable: true
        });
    
      // Добавляем многоугольник на карту.
      map.geoObjects.add(polygon)

      // В режиме добавления новых вершин меняем цвет обводки многоугольника.
      var stateMonitor = new window.ymaps.Monitor(polygon.editor.state)
      stateMonitor.add('drawing', function (newValue) {
        polygon.options.set('strokeColor', newValue ? '#FF0000' : '#0000FF')
      })
        // Включаем режим редактирования с возможностью добавления новых вершин.
        polygon.editor.startDrawing()

      }

    function newArea () {

      map.geoObjects.remove(polygon)
      onInitMap(map)
    }

    function makePostData(level, bc, params, polygon, folder, arProduct, priority, taskPrefix) {
      let realPolygon = null
      if (polygon && polygon.geometry && polygon.geometry.getCoordinates().length > 0 && polygon.geometry.getCoordinates()[0].length > 0 )
        realPolygon = polygon.geometry.getCoordinates()[0]
      let postData = 
        {   
          level:          level,
          bandCombination:bc,
          params:         params,
          polygon:        realPolygon,
          folder:         folder,
          input:          arProduct,
          priority:       priority,
          taskPrefix:     taskPrefix,
        }
      return postData
    }

    function updateBorder() {
      let dataServer = redouteProvider + '/geoborder'
      loaderActive.value = true
      axios.get(dataServer, {})
      .then(function (response) {
        result.value = response.data
        loaderActive.value = false
      })
      .catch(function (error) {
        result.value = error
        loaderActive.value = false
      });  
    }

    function makeProductFromFolder()  {
      let dataServer = redouteProvider + '/' + 'make'

      let postData = makePostData(selectedLevel.value, selectedBandComb.value, tamarinParam.value, catalog.polygon, folder.value, null, selectedPriority.value, taskPrefix.value)

      loaderActive.value = true
      let sPostData = JSON.stringify(postData)
      axios.post(dataServer, sPostData)
        .then(function (response) {
          if (response.data) alert(response.data)
          loaderActive.value = false
        })
        .catch(function (error) {
          result.value = error
          loaderActive.value = false
        });  
    }

    function makeProductFromCatalog()  {
      let dataServer = redouteProvider + '/' + 'make'

      // отобранные записи попадают в массив
      let arProduct = []
      let rows = catalog.table.rows;
      for (let row of rows) {
        arProduct.push(row.product)
      }

      if (!confirm('Всего заданий: ' + arProduct.length + '. Продолжить ?' )) return;

      let postData = makePostData(selectedLevel.value, selectedBandComb.value, tamarinParam.value, catalog.polygon, null, arProduct, selectedPriority.value, taskPrefix.value)

      let sPostData = JSON.stringify(postData)
      loaderActive.value = true
      axios.post(dataServer, sPostData)
        .then(function (response) {
          loaderActive.value = false
          if (response.data) alert(response.data)
        })
        .catch(function (error) {
          loaderActive.value = false
          alert(error)
        });  
    }

    function saveLink(action)  {
      let dataServer = redouteProvider + '/' + 'saveLink'

      // отобранные записи попадают в массив
      let arProduct = []
      let rows = catalog.table.rows;
      for (let row of rows) {
        arProduct.push({ productId: row.product } )
      }

      let postData = {  input:  arProduct,
                        name:   linkFolder.value,
                        action: action,
                     }

      axios.post(dataServer, JSON.stringify(postData)  )
        .then(function (response) {
          result.value = response.data
        })
        .catch(function (error) {
          result.value = error
        });  
    }

    function saveKit(action)  {
      let dataServer = redouteProvider + '/' + 'saveKit'

      // отобранные записи попадают в массив
      let arProduct = []
      let rows = catalog.table.rows;
      for (let row of rows) {
        arProduct.push({ productId: row.product } )
      }

      let postData = {  input:  arProduct,
                        name:   kitName.value,
                        action: action,
                     }

      axios.post(dataServer, JSON.stringify(postData)  )
        .then(function (response) {
          result.value = response.data
        })
        .catch(function (error) {
          result.value = error
        });  
    }

  return {
      searchTerm,
      coordsPolygon,
      onInitMap,
      find,
      updateBorder,
      selectedLevel,
      selectedBandComb,
      makeProductFromFolder,
      result,
      newArea,
      folder,
      tamarinParam,
      loaderActive,
      selectedPriority,
      taskPrefix,
      makeProductFromCatalog,
      linkFolder,
      kitName,
      saveLink,
      saveKit
    };
  },
});
</script>


<style scoped>

  :deep(.vtl-table td, .vtl-table th) {
    padding: 0.1rem;
    font-size: smaller;
  }

</style>

